%% Generate rec Raster plot in Figure 1d, 1f, 1h
clc;clear;close all;
stim_path = 'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2d-2l BNSTpr-Esr1-ChR2 or GFP\GFP\C02797523-1\stimulation file\pre-test_pup_sham light.txt';
%change path the related stimulation file
anno_path = 'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2d-2l BNSTpr-Esr1-ChR2 or GFP\GFP\C02797523-1\behavior annotation file\annotation_pre-test_pup_top.txt';
%change path to the related behavior annatation file


[Fstart, Fstop, behaviors] = inputtext(anno_path);
intro_id = strfind_part(behaviors, {'start'});
rmv_id = strfind_part(behaviors, {'stop'});
SFstart = Fstart(intro_id:rmv_id-1);
SFstop = Fstop(intro_id:rmv_id-1);
Sbehaviors = behaviors(intro_id:rmv_id-1);

% Find the corresponding trial immediately before Intro and after Rmv
% animal in Stim file to define the start and end point
[Fstart_stim, Fstop_stim, behaviors_stim] = inputtext(stim_path);
intro_id_stim = find(Fstart_stim<SFstart(1),1,'last');
rmv_id_stim = find(Fstop_stim>SFstop(end),1,'first');
SFstart_stim = Fstart_stim(intro_id_stim:rmv_id_stim); % SFstart_stim(1) = SFstart(1);
SFstop_stim = Fstop_stim(intro_id_stim:rmv_id_stim); % SFstop_stim(end) = SFstop(end);
Sbehaviors_stim = behaviors_stim(intro_id_stim:rmv_id_stim);

figure; hold on; axis off;
y_behavior = 0; h_behavior = 0.5;
y_stim = 0.55; h_stim = 0.04;


Shamlightid = strfind_part(Sbehaviors_stim, {'Sham-light'});
for i = 1:length(Shamlightid)
    rectangle('Position', [SFstart_stim(Shamlightid(i)) y_stim SFstop_stim(Shamlightid(i))-SFstart_stim(Shamlightid(i)) h_stim], 'FaceColor', 'k', 'EdgeColor', 'none')
end

Lightid = strfind_part(Sbehaviors_stim, {'Light'});
for i = 1:length(Lightid)
    rectangle('Position', [SFstart_stim(Lightid(i)) y_stim SFstop_stim(Lightid(i))-SFstart_stim(Lightid(i)) h_stim], 'FaceColor', 'b', 'EdgeColor', 'none')
end


Investigateid = strfind_part(Sbehaviors, {'Investigate-pup'});
for i = 1:length(Investigateid)
    rectangle('Position', [SFstart(Investigateid(i)) y_behavior SFstop(Investigateid(i))-SFstart(Investigateid(i)) h_behavior], 'FaceColor', 'y', 'EdgeColor', 'none')
end


Attackid = strfind_part(Sbehaviors, {'Attack-pup'});
for i = 1:length(Attackid)
    rectangle('Position', [SFstart(Attackid(i)) y_behavior SFstop(Attackid(i))-SFstart(Attackid(i)) h_behavior], 'FaceColor', 'r', 'EdgeColor', 'none')
end

Retrieveid = strfind_part(Sbehaviors, {'Retrieve-pup'});
for i = 1:length(Retrieveid)
    rectangle('Position', [SFstart(Retrieveid(i)) y_behavior SFstop(Retrieveid(i))-SFstart(Retrieveid(i)) h_behavior], 'FaceColor', 'g', 'EdgeColor', 'none')
end

hold off;

