%% Calculate mCherry_saline group latency to retrieve and attack
clc; clear; close all;
A_anno_path={'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02781096_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840576_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840577_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840579_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840581_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840582_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840583_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840852_annotation_saline_pup_top.txt'};

for k = 1: length(A_anno_path)

anno_path = A_anno_path{k};

[Fstart, Fstop, behaviors] = inputtext(anno_path);
intro_id = strfind_part(behaviors, {'start'});
rmv_id = strfind_part(behaviors, {'stop'});
SFstart = Fstart(intro_id:rmv_id-1);
SFstop = Fstop(intro_id:rmv_id-1);
Sbehaviors = behaviors(intro_id:rmv_id-1);

figure; hold on;

Introid = strfind_part(Sbehaviors, {'Intro-pup'});
for i = 1:length(Introid)
    rectangle('Position', [(SFstart(Introid(i))-Fstop(intro_id))/25 0 (SFstop(Introid(i))-SFstart(Introid(i)))/25 0.2], 'FaceColor', 'k', 'EdgeColor', 'none')
    
end

Retrieveid = strfind_part(Sbehaviors, {'Retrieve-pup'});
for i = 1:length(Retrieveid)
    rectangle('Position', [(SFstart(Retrieveid(i))-Fstop(intro_id))/25 0 (SFstop(Retrieveid(i))-SFstart(Retrieveid(i)))/25 0.2], 'FaceColor', 'b', 'EdgeColor', 'none')
    
end

Attackid = strfind_part(Sbehaviors, {'Attack-pup'});
for i = 1:length(Attackid)
    rectangle('Position', [(SFstart(Attackid(i))-Fstop(intro_id))/25 0 (SFstop(Attackid(i))-SFstart(Attackid(i)))/25 0.2], 'FaceColor', 'r', 'EdgeColor', 'none')
    
end

Sniffid = strfind_part(Sbehaviors, {'Investigate-pup'});
for i = 1:length(Sniffid)
    rectangle('Position', [(SFstart(Sniffid(i))-Fstop(intro_id))/25 0 (SFstop(Sniffid(i))-SFstart(Sniffid(i)))/25 0.2], 'FaceColor', 'y', 'EdgeColor', 'none')

end

set(gca,'ytick',[]);
set(gca,'xtick',[]);
box on;

ylabel('');xlabel('');
xlim([0 600]);
hold off;


Intro_pup_id = strfind_part(Sbehaviors, {'Intro-pup'});

if length(Retrieveid) <1
   Retrieve_latency (1,k) = 600; 
else
Retrieve_latency (1,k) = (SFstart (Retrieveid(1)) - SFstop(Intro_pup_id))/25;
end

if length(Attackid) <1
    Attack_latency (1,k) = 600; 
else
Attack_latency (1,k) = (SFstart (Attackid(1)) - SFstop(Intro_pup_id))/25;
end


end

save ('mCherry_saline_latency_to_retrieve and attack.mat','Retrieve_latency','Attack_latency');

%% Calculate mCherry_CNO group  latency to retrieve and attack
clc; clear; close all;
A_anno_path={'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02781096_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840576_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840577_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840579_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840581_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840582_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840583_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\mCherry\C02840852_annotation_CNO_pup_top.txt'};


for k = 1: length(A_anno_path)

anno_path = A_anno_path{k};

[Fstart, Fstop, behaviors] = inputtext(anno_path);
intro_id = strfind_part(behaviors, {'start'});
rmv_id = strfind_part(behaviors, {'stop'});
SFstart = Fstart(intro_id:rmv_id-1);
SFstop = Fstop(intro_id:rmv_id-1);
Sbehaviors = behaviors(intro_id:rmv_id-1);

figure; hold on;

Introid = strfind_part(Sbehaviors, {'Intro-pup'});
for i = 1:length(Introid)
    rectangle('Position', [(SFstart(Introid(i))-Fstop(intro_id))/25 0 (SFstop(Introid(i))-SFstart(Introid(i)))/25 0.2], 'FaceColor', 'k', 'EdgeColor', 'none')
    
end

Retrieveid = strfind_part(Sbehaviors, {'Retrieve-pup'});
for i = 1:length(Retrieveid)
    rectangle('Position', [(SFstart(Retrieveid(i))-Fstop(intro_id))/25 0 (SFstop(Retrieveid(i))-SFstart(Retrieveid(i)))/25 0.2], 'FaceColor', 'b', 'EdgeColor', 'none')
    
end

Attackid = strfind_part(Sbehaviors, {'Attack-pup'});
for i = 1:length(Attackid)
    rectangle('Position', [(SFstart(Attackid(i))-Fstop(intro_id))/25 0 (SFstop(Attackid(i))-SFstart(Attackid(i)))/25 0.2], 'FaceColor', 'r', 'EdgeColor', 'none')
    
end

Sniffid = strfind_part(Sbehaviors, {'Investigate-pup'});
for i = 1:length(Sniffid)
    rectangle('Position', [(SFstart(Sniffid(i))-Fstop(intro_id))/25 0 (SFstop(Sniffid(i))-SFstart(Sniffid(i)))/25 0.2], 'FaceColor', 'y', 'EdgeColor', 'none')

end

set(gca,'ytick',[]);
set(gca,'xtick',[]);
box on;

ylabel('');xlabel('');
xlim([0 600]);
hold off;


Intro_pup_id = strfind_part(Sbehaviors, {'Intro-pup'});

if length(Retrieveid) <1
   Retrieve_latency (1,k) = 600; 
else
Retrieve_latency (1,k) = (SFstart (Retrieveid(1)) - SFstop(Intro_pup_id))/25;
end

if length(Attackid) <1
    Attack_latency (1,k) = 600; 
else
Attack_latency (1,k) = (SFstart (Attackid(1)) - SFstop(Intro_pup_id))/25;
end


end

save ('mCherry_CNO_latency_to_Retrieve and attack.mat','Retrieve_latency','Attack_latency');

%% Calculate hM3Dq_saline group  latency to retrieve and attack
clc; clear; close all;
A_anno_path={'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02741088_annotation_saline.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840567_annotation_saline.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840568_annotation_saline.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840569_annotation_saline.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840571_annotation_saline.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840586_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840591_annotation_saline_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840838_annotation_saline_pup.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840841_annotation_saline_pup.txt'};


for k = 1: length(A_anno_path)

anno_path = A_anno_path{k};

[Fstart, Fstop, behaviors] = inputtext(anno_path);
intro_id = strfind_part(behaviors, {'start'});
rmv_id = strfind_part(behaviors, {'stop'});
SFstart = Fstart(intro_id:rmv_id-1);
SFstop = Fstop(intro_id:rmv_id-1);
Sbehaviors = behaviors(intro_id:rmv_id-1);

figure; hold on;

Introid = strfind_part(Sbehaviors, {'Intro-pup'});
for i = 1:length(Introid)
    rectangle('Position', [(SFstart(Introid(i))-Fstop(intro_id))/25 0 (SFstop(Introid(i))-SFstart(Introid(i)))/25 0.2], 'FaceColor', 'k', 'EdgeColor', 'none')
    
end

Retrieveid = strfind_part(Sbehaviors, {'Retrieve-pup'});
for i = 1:length(Retrieveid)
    rectangle('Position', [(SFstart(Retrieveid(i))-Fstop(intro_id))/25 0 (SFstop(Retrieveid(i))-SFstart(Retrieveid(i)))/25 0.2], 'FaceColor', 'b', 'EdgeColor', 'none')
    
end

Attackid = strfind_part(Sbehaviors, {'Attack-pup'});
for i = 1:length(Attackid)
    rectangle('Position', [(SFstart(Attackid(i))-Fstop(intro_id))/25 0 (SFstop(Attackid(i))-SFstart(Attackid(i)))/25 0.2], 'FaceColor', 'r', 'EdgeColor', 'none')
    
end

Sniffid = strfind_part(Sbehaviors, {'Investigate-pup'});
for i = 1:length(Sniffid)
    rectangle('Position', [(SFstart(Sniffid(i))-Fstop(intro_id))/25 0 (SFstop(Sniffid(i))-SFstart(Sniffid(i)))/25 0.2], 'FaceColor', 'y', 'EdgeColor', 'none')

end

set(gca,'ytick',[]);
set(gca,'xtick',[]);
box on;

ylabel('');xlabel('');
xlim([0 600]);
hold off;


Intro_pup_id = strfind_part(Sbehaviors, {'Intro-pup'});

if length(Retrieveid) <1
   Retrieve_latency (1,k) = 600; 
else
Retrieve_latency (1,k) = (SFstart (Retrieveid(1)) - SFstop(Intro_pup_id))/25;
end

if length(Attackid) <1
    Attack_latency (1,k) = 600; 
else
Attack_latency (1,k) = (SFstart (Attackid(1)) - SFstop(Intro_pup_id))/25;
end


end

save ('hM4Di_saline_latency_to_Retrieve and attack.mat','Retrieve_latency','Attack_latency');

%% Calculate hM3Dq_CNO group  latency to retrieve and attack
clc; clear; close all;
A_anno_path={'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02741088_annotation_CNO.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840567_annotation_CNO.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840568_annotation_CNO.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840569_annotation_CNO.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840571_annotation_CNO.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840586_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840591_annotation_CNO_pup_top.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840838_annotation_CNO_pup.txt'
'Z:\linlabspace\Paper Raw Data\2023_Nature_Mei\Figure 2\2p-2s BNSTpr-Esr1-Gi or mCherry\Gi\C02840841_annotation_CNO_pup.txt'};


for k = 1: length(A_anno_path)

anno_path = A_anno_path{k};

[Fstart, Fstop, behaviors] = inputtext(anno_path);
intro_id = strfind_part(behaviors, {'start'});
rmv_id = strfind_part(behaviors, {'stop'});
SFstart = Fstart(intro_id:rmv_id-1);
SFstop = Fstop(intro_id:rmv_id-1);
Sbehaviors = behaviors(intro_id:rmv_id-1);

figure; hold on;

Introid = strfind_part(Sbehaviors, {'Intro-pup'});
for i = 1:length(Introid)
    rectangle('Position', [(SFstart(Introid(i))-Fstop(intro_id))/25 0 (SFstop(Introid(i))-SFstart(Introid(i)))/25 0.2], 'FaceColor', 'k', 'EdgeColor', 'none')
    
end

Retrieveid = strfind_part(Sbehaviors, {'Retrieve-pup'});
for i = 1:length(Retrieveid)
    rectangle('Position', [(SFstart(Retrieveid(i))-Fstop(intro_id))/25 0 (SFstop(Retrieveid(i))-SFstart(Retrieveid(i)))/25 0.2], 'FaceColor', 'b', 'EdgeColor', 'none')
    
end

Attackid = strfind_part(Sbehaviors, {'Attack-pup'});
for i = 1:length(Attackid)
    rectangle('Position', [(SFstart(Attackid(i))-Fstop(intro_id))/25 0 (SFstop(Attackid(i))-SFstart(Attackid(i)))/25 0.2], 'FaceColor', 'r', 'EdgeColor', 'none')
    
end

Sniffid = strfind_part(Sbehaviors, {'Investigate-pup'});
for i = 1:length(Sniffid)
    rectangle('Position', [(SFstart(Sniffid(i))-Fstop(intro_id))/25 0 (SFstop(Sniffid(i))-SFstart(Sniffid(i)))/25 0.2], 'FaceColor', 'y', 'EdgeColor', 'none')

end

set(gca,'ytick',[]);
set(gca,'xtick',[]);
box on;

ylabel('');xlabel('');
xlim([0 600]);
hold off;


Intro_pup_id = strfind_part(Sbehaviors, {'Intro-pup'});

if length(Retrieveid) <1
   Retrieve_latency (1,k) = 600; 
else
Retrieve_latency (1,k) = (SFstart (Retrieveid(1)) - SFstop(Intro_pup_id))/25;
end

if length(Attackid) <1
    Attack_latency (1,k) = 600; 
else
Attack_latency (1,k) = (SFstart (Attackid(1)) - SFstop(Intro_pup_id))/25;
end


end

save ('hM4Di_CNO_latency_to_Retrieve and attack.mat','Retrieve_latency','Attack_latency');
